3 # Author: Alan J. Pippin (apippin@pippins.net)
8 # Description: This script wraps a number of linux utilities to
9 # create a recipe for ripping protected DVDs, circumventing
10 # ARcoSS and CRC checksum error protection schemes used on many
11 # newer DVDs. Edit as appropriate for your needs. I use this to
12 # backup DVDs I own, and do not condone any other activity it
15 # Known Issues/Limitations:
16 # - Mirror mode is always done in ISO mode
18 # Package Dependencies:
19 # lsdvd dvdauthor gddrescue dvdbackup makexml tovid mencoder vlc mplayer genisoimage
21 # Optional Dependencies:
22 # lookup imdb info/posters for mythvideo: http://www.mythtv.org/wiki/Fill_mythvideo_metadata.pl
25 ###############################################
26 # Local Machine Settings - EDIT THIS SECTION
28 # Specify the device path to the DVD drive
31 # Specify the path to the log directory
32 logdir=/var/log/ripdvd
34 # Specify the path to the tmp rip directory
35 tmpdir=/myth/video/DVDs/.ripdvd
37 # Specify the email address to send job notifications to
38 mailto=ajp@pippins.net
40 # Setup the path to the tools needed by this ripper
41 PATH=/etc/mythtv/bin:/usr/local/bin:/usr/sbin:/sbin:/usr/bin:.:$PATH
43 # Use mplayer dumpstream to create the main VOB file
44 # If set to 0, cat and other utils will be used to make it instead.
45 # Using mplayer dumpstream is by far the best way to create the main VOB file
46 # The only thing this doesn't work for are DVDs with the 99 title copy protection.
47 # The script will autodetect these types of disks, and change this to 0 if necessary.
48 # If this is set to 0, other methods will be employed to get the DVD VOB dump.
49 use_mplayer_dumpstream=1
51 # 2-channel AVI encoding audio bit rate
54 # If set to 1, this script will call another script to fill in the mythvideo metadata
55 # If you don't use mythtv, set this option to 0. If you use mythtv, and have downloaded
56 # the fill_mythvideo_metadata.pl script shown above, you can leave this option set to 1.
57 fill_mythvideo_metadata=1
59 # If the 99 titleset copy protection scheme is detected, trust the autodetection or abort.
60 # The autodetection may work, but it probably won't in this case. Set to 0 by default.
61 # Override to 1 if you want the script to wing it, and hope it picks the right feature title.
62 # Otherwise, you will need to rerun the script providing the feature title with the -t option.
63 trust_feature_title_autodetect_when_uncertain=0
65 # specify the number of threads that mencoder should use when encoding the video (AVI mode)
66 # an optimal setting for this should be the number of cores you have times 2
67 # note: you have to have an mplayer version that has been compiled with multi thread support.
68 # if you don't, this will have no effect, but won't hurt anything to have it set otherwise.
71 ###############################################
72 # Command line processing
79 typeset -i keep_intermediate_files=0
80 typeset -i make_final_dest_vob=0
81 typeset -i make_final_dest_iso=0
82 typeset -i make_final_dest_folder=0
83 typeset -i make_final_dest_avi=0
85 typeset -i show_usage=0
86 typeset -i mirror_mode=0
87 typeset -i target_bitrate=0
88 typeset -i target_size=0
89 typeset -i audio_2ch=0
90 typeset -i invalid_feature_title=0
91 typeset -i feature_title_override=0
92 typeset -i mplayer_dumpstream_incompatibility=0
94 while (($#)) && getopts 2mvifkxht:n:d:b:s:t: opt "$@"
99 (b) target_bitrate=$OPTARG;;
100 (s) target_size=$OPTARG;;
102 (v) make_final_dest_vob=1;;
103 (i) make_final_dest_iso=1;;
104 (f) make_final_dest_folder=1;;
105 (x) make_final_dest_avi=1;;
107 (k) keep_intermediate_files=1;;
108 (t) feature_title_override=$OPTARG;;
111 (:) echo >&2 "$0: $OPTARG requires a value"; errors=errors+1;;
112 (\?) echo >&2 "$0: invalid option '$OPTARG'"; errors=errors+1;;
119 echo >&2 "Usage: ${0##*/} -d <destdir> [ <options> ]"
120 echo >&2 "Revision $REV"
122 echo >&2 " -d <destdir> Specify the destination directory to store the ripped DVD to"
123 echo >&2 " -n <dvdname> Specify a path to a DVD folder or file to process:"
124 echo >&2 " 1) If this option is not specified, the DVD will be ripped from $dev"
125 echo >&2 " 2) If dvdname exists in $tmpdir, it will be ripped as a DVD instead of $dev"
126 echo >&2 " 3) If dvdname is a full path to a DVD folder, it will be ripped as a DVD instead of $dev"
127 echo >&2 " 4) If dvdname is a full path to an MPG2 file, it will be ripped as a DVD instead of $dev"
128 echo >&2 " -m Make a mirror image of the DVD and save it as a DVD ISO file"
129 echo >&2 " The default operation is non-mirror mode where only the main"
130 echo >&2 " feature title will be ripped."
131 echo >&2 " -v Make the final image a DVD VOB file"
132 echo >&2 " -i Make the final image a DVD ISO file"
133 echo >&2 " -f Make the final image a DVD folder"
134 echo >&2 " -x Make the final image an AVI (XVID) file"
135 echo >&2 " You must also specify the target size or bitrate using the '-s' or '-b' options"
136 echo >&2 " -s <size> Set the target size of the AVI file in MB (ex: 700, 1000, etc)"
137 echo >&2 " -b <bitrate> Set the bitrate desired in the AVI file in kbits/sec (ex: 1500, 2000 (default), etc)"
138 echo >&2 " -2 Use 2 channel MP3 audio encoding when making an AVI file (default is 6 channel AC3)"
139 echo >&2 " -k Keep the intermediate files (good for debugging)"
140 echo >&2 " In -x mode, run with this option to keep the original .VOB file"
141 echo >&2 " By default, all intermediary files are deleted. Only the final image is kept"
142 echo >&2 " -t <title> Specify the main feature title to pull from the DVD (only required if this script can't figure it out)"
143 echo >&2 " -w Set the sh Execute/Verbose flag"
148 if (($errors)) || (($show_usage))
153 # Sanity Check - Command Line Options
154 if [ "$dest" == "" ]; then
155 echo "-E- You must specify a destination directory with '-d'" | tee -a $logfile
159 if ([ $target_bitrate -ne 0 ] || [ $target_size -ne 0 ]) && [ $make_final_dest_avi -ne 1 ]; then
160 echo "-E- You can't specify a bitrate in non AVI file mode. You must specify '-x' when using '-b' or '-s'" | tee -a $logfile
164 if [ $target_bitrate -eq 0 ] && [ $target_size -eq 0 ] && [ $make_final_dest_avi -eq 1 ]; then
165 echo "-E- You must specify a bitrate in AVI file mode. You must specify '-b' or '-s' when using '-x'" | tee -a $logfile
169 if [ $make_final_dest_vob -eq 0 ] && [ $make_final_dest_iso -eq 0 ] &&
170 [ $make_final_dest_folder -eq 0 ] && [ $make_final_dest_avi -eq 0 ] && [ $mirror_mode -eq 0 ]; then
171 echo "-E- You must specify what type of final destination you want: '-m' or '-v' or '-i' or '-f' or '-x'" | tee -a $logfile
175 if [ $mirror_mode -eq 1 ]; then
176 if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_iso -eq 1 ] ||
177 [ $make_final_dest_folder -eq 1 ] || [ $make_final_dest_avi -eq 1 ]; then
178 echo "-E- You can't specify '-v' or '-i' or '-f' or '-x' when operating in mirror mode with '-m'" | tee -a $logfile
183 # Sanity Check - Key executables
184 [[ ! -x `which lsdvd` ]] && echo "-E- missing dependency: lsdvd" && exit
185 [[ ! -x `which volname` ]] && echo "-E- missing dependency: volname" && exit
186 [[ ! -x `which ddrescue` ]] && echo "-E- missing dependency: ddrescue" && exit
187 [[ ! -x `which dvdbackup` ]] && echo "-E- missing dependency: dvdbackup" && exit
188 [[ ! -x `which mencoder` ]] && echo "-E- missing dependency: mencoder" && exit
189 [[ ! -x `which makexml` ]] && echo "-E- missing dependency: makexml" && exit
190 [[ ! -x `which dvdauthor` ]] && echo "-E- missing dependency: dvdauthor" && exit
191 [[ ! -x `which mkisofs` ]] && echo "-E- missing dependency: mkisofs" && exit
193 ###############################################
196 if [ -z "$dvdname" ]; then
197 # make sure the DVD device is accessible
198 volname $dev > /dev/null 2>&1
200 echo "-E- Can't access the DVD device $dev"
203 # now capture the volume name from the device
204 dvdname=`volname $dev | awk '{ print $1 }'`
207 # check to see if dvdname is a full path to a real directory
208 # if it is, set dvdname and dvdpath appropriately
209 if [ -d "$dvdname" ]; then
211 dvdname=`basename "$dvdname"`
212 if [ -z "$dvdname" ]; then
213 echo "-E- Unable to extract dvdname from path: $dvdpath"
216 if [ ! -d "$dvdpath/VIDEO_TS" ]; then
217 echo "-E- You must supply a full path to a valid DVD folder with this option"
221 # check to see if dvdname is a full path to an MPG2 (VOB) file
222 # if it is, set dvdname and vobfile appropriately
223 if [ -f "$dvdname" ]; then
225 dvdname=`basename "$dvdname"`
226 file "$vobfile" | grep -q "MPEG"
228 # It is a valid MPEG2 file, now strip the extension off our dvdname
229 dvdname=${dvdname%.[^.]*}
231 echo "-E- Unsupported file type: $vobfile"
238 # remove bad characters from the dvdname
239 dvdname=${dvdname%.} # remove trailing '.' character
241 # make a "safe" dvdname (remove special characters)
242 safedvdname=`basename "$dvdname" | sed 's/[ !&*\\$?]/_/g'`
244 # Make sure we have a non-empty dvdname
245 if [ -z "$dvdname" ]; then
246 echo "-E- unable to determine dvdname"
250 # make sure our vobfile value is set
251 if [ -z "$vobfile" ]; then
252 vobfile="$dest/$dvdname.VOB"
255 # set up some variables to hold various logfiles
256 logfile="$logdir/$dvdname.log"
257 passlogfile="$tmpdir/$safedvdname.log"
258 ddrescuelog=`tempfile`
259 dvdauthorlog=`tempfile`
263 # create the tmpdir if it doesn't already exist
264 if [ ! -d "$tmpdir" ]; then
267 echo "-E- Unable to create the tmpdir: $tmpdir"
272 # create the logdir if it doesn't already exist
273 if [ ! -d "$logdir" ]; then
276 echo "-E- Unable to create the logdir: $logdir"
281 ###############################################
284 if [ $keep_intermediate_files -eq 0 ]; then
285 [[ -e "$dvdauthorlog" ]] && rm -f "$dvdauthorlog"
286 [[ -e "$ddrescuelog" ]] && rm -f "$ddrescuelog"
287 [[ -e "$encodelog" ]] && rm -f "$encodelog"
288 [[ -e "$dumplog" ]] && rm -f "$dumplog"
290 [[ -e "$dvdauthorlog" ]] && echo "-> Keeping dvdauthor log: $dvdauthorlog" | tee -a "$logfile"
291 [[ -e "$ddrescuelog" ]] && echo "-> Keeping ddrescue log: $ddrescuelog" | tee -a "$logfile"
292 [[ -e "$encodelog" ]] && echo "-> Keeping encode log: $encodelog" | tee -a "$logfile"
293 [[ -e "$dumplog" ]] && echo "-> Keeping dump log: $dumplog" | tee -a "$logfile"
299 if [[ -z "$1" ]]; then
300 msg="-E- control-c killed us"
304 echo -e 2>&1 "$msg" | tee -a "$logfile"
305 if [[ -n "$mailto" ]]; then
306 echo -e "$msg" | mailx -s "dvd rip of $dvdname FAILED" "$mailto"
311 # Call our cleanup functions on INT and EXIT signals
312 trap fatal_and_exit INT
315 ###############################################
316 # processing functions
317 function make_dvd_iso_image {
321 # check to see if we have a dvdpath to rip from instead of $dev
322 if [ -z "$dvdpath" ]; then
323 # load the CSS codes in the DVD drive
324 lsdvd $dev >> "$logfile"
326 fatal_and_exit "-E- lsdvd $dev failed"
329 # read the DVD, ignoring/skipping CRC errors
330 ddrescue -n -b 2048 $dev "$isofile" "$ddrescuelog"
332 fatal_and_exit "-E- ddrescue -n -b 2048 $dev \"$isofile\" failed"
334 cat "$ddrescuelog" >> "$logfile"
336 # rip from a path instead
337 make_dvd_iso_image_from_folder "$dvdpath" "$isofile" 1
341 function make_dvd_iso_image_from_folder {
347 echo "-> Creating ISO image of DVD video: $src -> $dst" | tee -a "$logfile"
349 # make an iso image out of our directory
350 echo " mkisofs -dvd-video \"$src\" 2>> \"$dumplog\" | dd of=\"$dst\" obs=32k seek=0 > /dev/null 2>> $dumplog" >> "$logfile"
351 mkisofs -dvd-video "$src" 2>> "$dumplog" | dd of="$dst" obs=32k seek=0 > /dev/null 2>> "$dumplog"
353 # set the audio languages from the iso if it exists and is non-zero in size
354 if [ -s "$dst" ]; then
355 get_feature_title "$dst"
356 get_audio_id_from_iso "$dst"
359 # make sure we were able to create the iso image from the folder given to us
360 if [ ! -s "$dst" ] && [ $handle_error -eq 1 ]; then
361 echo "-> Unable to make an iso image from the DVD folder: $dvdpath"
362 echo " Falling back to mplayer to create a main feature VOB from the folder instead: $dvdpath"
363 # remove the bad iso file
364 [[ -e "$dst" ]] && rm -f "$dst"
365 # get the feature title from the DVD folder
366 get_feature_title "$dvdpath"
367 # create our main VOB file from the ISO
368 create_main_vob_with_mplayer "$dvdpath"
369 # get our audio id from the VOB file
370 get_audio_id_from_vob "$vobfile"
374 function make_dvdbackup_folder_image {
375 # extract the feature title from the DVD image
376 echo "-> Extracting feature title using dvdbackup" | tee -a "$logfile"
377 [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
378 dvdbackup -F -i "$isofile" -o "$tmpdir" >> "$logfile"
380 fatal_and_exit '-E- dvdbackup -F -i "$isofile" -o "$tmpdir" failed'
384 function make_dvdauthor_folder_image {
385 # create a new DVD video of the feature title
386 echo "-> Creating DVD video $dest/$dvdname" | tee -a "$logfile"
387 [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
388 dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
389 cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
391 # There is a chance that dvdauthor won't like some of the VOBs.
392 # We can't tell ahead of time which ones it will choke on.
393 # So, we need to run it over and over again until it can process
394 # all the VOBs. If it can't handle one of them, run it through
395 # mencoder to fix it and try again. These errors are typically
396 # present due to the copy protection that ddrescue removed.
397 grep -q "SCR moves" $dvdauthorlog
398 while [ $? == 0 ]; do
399 # fix bad vobs that get the "SCR moves backwards" error:
400 # STAT: Processing VTS_01_0.VOB...
401 # ERR: SCR moves backwards, remultiplex input.
402 badvob=`grep -v "^WARN:" $dvdauthorlog | grep -B 1 "SCR moves" | grep "Processing" | awk '{ print $3 }' | sed -e 's/\.\.\.//'`
403 if [[ ! -f "$badvob" ]]; then
404 fatal_and_exit "-E- Found a bad VOB, but could not extract it's name properly: $badvob"
406 echo "-> Fixing SCR errors in DVD video file $badvob" | tee -a "$logfile"
407 cat $badvob | mencoder $lang_opts -quiet -of mpeg -mpegopts format=dvd -oac copy -ovc copy - -o $badvob.fixed >> "$logfile" 2>&1
408 mv -f $badvob.fixed $badvob
409 echo "-> Creating DVD video $dest/$dvdname"
410 dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
411 cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
412 grep -q "SCR moves" $dvdauthorlog
416 function get_feature_title {
418 # if a feature title was given on the command line, use it
419 if [ $feature_title_override -ne 0 ]; then
420 feature_title=$feature_title_override
423 # otherwise, use lsdvd to figure it out
424 if [ $ripdvd -eq 1 ]; then
425 feature_title=`lsdvd $dev | awk '/Longest/ { print $NF }'`
427 feature_title=`lsdvd "$source" 2>/dev/null | awk '/Longest/ { print $NF }'`
431 function create_main_vob_with_cat {
432 # cd to the feature title DVD folder
433 pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
435 fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
438 # concatenate all the VOBs together into 1 giant VOB
439 vobs=`/bin/ls -1 VTS*.VOB | grep -v "0.VOB" | tr '\n' ' '`
440 cat $vobs > "$tmpdir/$dvdname.VOB"
442 # cd back to the dir we started from
443 popd > /dev/null 2>&1
446 function create_main_vob_with_mplayer {
448 # argument processing
452 # make sure we have a valid feature title
453 if [ $invalid_feature_title -eq 1 ] && [ $feature_title_override -eq 0 ]; then
454 fatal_and_exit "-E- You must have a valid feature title to get the VOB via mplayer dumpstream. We can't determine the feature title for this DVD."
457 # check to make sure we didn't detect an mplayer dumpstream incompatibility earlier
458 if [ $mplayer_dumpstream_incompatibility -eq 1 ]; then
459 msg="-E- We detected an mplayer dumpstream incompatibility earlier."
460 msg="$msg We also detected another condition that requires us to use dumpstream. "
461 msg="$msg\n Unable to rip this DVD in the mode you requested."
462 fatal_and_exit "$msg"
465 # use mplayer to create the main VOB file
466 echo "-> Using mplayer to dump the DVD feature title $feature_title to a VOB file directly: $vobfile" | tee -a "$logfile"
467 echo " mplayer $lang_opts -dumpstream -dumpfile \"$vobfile\" -dvd-device \"$source\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
468 mplayer $lang_opts -dumpstream -dumpfile "$vobfile" -dvd-device "$source" dvd://$feature_title > $dumplog 2>&1
470 cat $dumplog | grep -v "^A:" >> "$logfile"
471 fatal_and_exit "-E- Mplayer Failed"
473 cat $dumplog | grep -v "^A:" >> "$logfile"
474 [[ -e "$dumplog" ]] && [[ $remove_dumplog -eq 1 ]] && rm -f $dumplog
477 function get_audio_id_from_iso {
478 # Adjust our audio ID to find the english audio stream
479 # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
483 mplayer -v -endpos 0 -dvd-device "$iso" dvd://$feature_title > $aidcheck 2>&1
484 grep -q "aid: $aid" $aidcheck
485 while [ $? == 1 ] && [ $aid -lt 159 ]; do
487 grep -q "aid: $aid" $aidcheck
489 [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
490 echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
491 # mencoder default DVD audio track language selection (english)
492 lang_opts="-aid $aid -alang en"
495 function get_crop_from_iso {
497 echo "-> Detecting black frame border crop value from ISO file"
498 echo " mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device \"$isofile\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
499 mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device "$isofile" dvd://$feature_title > $dumplog 2>&1
500 [[ -e "md5sums" ]] && rm -f "md5sums"
501 CROP=`cat $dumplog | grep CROP | tail -1`
502 echo " Found crop value of $CROP" >> "$logfile"
506 CROPCHECK=`echo "$CROP" | awk -F ':' '{ print $1 }'`
507 echo " Final crop value of $CROP with cropcheck value of $CROPCHECK" >> "$logfile"
508 if [ -z "$CROP" ]; then
509 fatal_and_exit "-E- Unable to extract CROP value from iso: $isofile"
511 if [ $CROPCHECK -lt 0 ]; then
516 echo " Setting mencoder crop filter to: $CROP"
519 function get_audio_id_from_vob {
520 # Adjust our audio ID to find the english audio stream
521 # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
525 mplayer -v -endpos 0 "$vob" > $aidcheck 2>&1
526 grep -q "Found audio stream: $aid" $aidcheck
527 while [ $? == 1 ] && [ $aid -lt 159 ]; do
529 grep -q "Found audio stream: $aid" $aidcheck
531 [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
532 echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
533 # mencoder default DVD audio track language selection (english)
534 lang_opts="-aid $aid -alang en"
537 function check_vob_for_corrupted_start {
538 # check to see if the beginning of the DVD has a form of copy protection
539 # where they have deliberately broken the first X number of frames of the DVD.
540 # If we don't skip these, our resulting VOB file will not play.
541 badvobcheck=`tempfile`
544 mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
546 fatal_and_exit "-E- Mencoder Failed"
548 grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
549 while [ $? == 0 ] && [ $skip -lt $endpos ]; do
550 (( skip = skip + 5 ))
551 echo "-> Bad VOB copy protection detected. Trying new skip value of $skip" | tee -a "$logfile"
552 mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
554 fatal_and_exit "-E- Mencoder Failed"
556 grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
558 [[ -e "$badvobcheck" ]] && rm -f "$badvobcheck";
560 # cat the giant VOB into mencoder to create a playable VOB file
561 cat "$tmpdir/$dvdname.VOB" | mencoder -ss $skip -quiet $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy - -o "$vobfile" >> "$logfile" 2>&1
563 fatal_and_exit "-E- Mencoder Failed"
567 function check_vob_for_completeness {
568 # check to make sure we got out a complete VOB.
569 # there is another kind of copy protection where the VOB's may
570 # have "MPG EOF" frames in the middle of the stream.
571 # this causes mencoder to not process the entire VOB, and exit without any errors.
572 # detect this by seeing how much smaller the dst vob is from the src vob.
573 MAX_FILESIZE_DELTA_PERCENT=70
574 SRC_VOB_FILESIZE=$(stat -c%s "$tmpdir/$dvdname.VOB")
575 DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
576 FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
577 if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
578 # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
579 echo "-> Detected bad VOB size copy protection after processing concatenated VOB file." | tee -a "$logfile"
580 create_main_vob_with_mplayer "$isofile"
581 [[ -e "$dumplog" ]] && rm -f $dumplog
582 DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
583 FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
584 if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
585 fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n I recommend using another ripping mode like '-m' or '-i'"
590 function check_vob_for_too_many_video_packets {
591 # If our earlier algorithm to work around this failed, throw an error.
592 # check to see if this DVD has a protection scheme we don't know how to work around
593 # when I tried to burn the CARS DVD for example, you can't play the resulting VOB file.
594 # for some reason, the video is black, while the audio rolls, then the video finally comes
595 # in, but it is WAY off the audio. This appears to be due to some bad frames at the beginning of
596 # the 1st VOB. Until I figure out how to work around this, detect it, and error out.
597 # instead of pulling the image from the disk again, you can pull it directly from the iso: -dvd-device $iso_path
598 grep -q "Too many video packets in the buffer:" "$logfile"
600 # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
601 echo "-> Detected corrupt audio stream copy protection after processing concatenated VOB file." | tee -a "$logfile"
602 create_main_vob_with_mplayer "$isofile"
603 grep -q "Too many video packets in the buffer:" $dumplog
605 [[ -e "$dumplog" ]] && rm -f $dumplog
606 fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n I recommend using another ripping mode like '-m' or '-i'"
608 [[ -e "$dumplog" ]] && rm -f $dumplog
612 function check_vob_for_a52_crc_errors {
613 # Let's see if we can playback our newly created VOB file without any errors.
614 # if there are issues, let's detect them now, and try to recreate the VOB
615 # there are some forms of copy protection that have missed above, that evidence
616 # themselves when we try to playback the VOB file. This was added to deal with
617 # the "a52: CRC check failed" copy protection scheme.
620 echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
621 mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
622 cat $dumplog | grep -v "^A:" >> "$logfile"
623 errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
624 if [ $errors -gt $MAX_ERRORS ]; then
625 echo "-> Detected a52 audio stream CRC errors copy protection after processing concatenated VOB file." | tee -a "$logfile"
626 create_main_vob_with_mplayer "$isofile"
627 echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
628 mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
630 cat $dumplog | grep -v "^A:" >> "$logfile"
631 fatal_and_exit "-E- Mplayer Failed"
633 cat $dumplog | grep -v "^A:" >> "$logfile"
634 errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
635 if [ $errors -gt $MAX_ERRORS ]; then
636 fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n I recommend using another ripping mode like '-m' or '-i'"
639 [[ -e "$dumplog" ]] && rm -f $dumplog
642 function calculate_bitrate_from_target_size {
643 # determine what our bitrate needs to be if a target size was specified instead
644 if [ $target_size -ne 0 ]; then
645 vob_length=`mplayer -identify -v "$vobfile" -endpos 0 2>&1 | grep ID_LENGTH | awk -F '=' '{ print $2 }' | awk -F '.' '{ print $1 }'`
646 ((target_bitrate = (target_size * 1024 * 8) / vob_length ))
647 echo " With a given target size of $target_size MB, the estimated bit rate will need to be $target_bitrate kbits/sec"
651 function create_dvdauthor_dvd_xml_file {
652 # make a dvdauthor xml menu file to create a valid DVD video from
653 # this script does a good job, but we'll still need to clean it up a bit after it runs
654 echo "-> Creating dvdauthor XML menu file" | tee -a "$logfile"
655 makexml -overwrite -dvd *.VOB -out dvd >> "$logfile" 2>&1
657 fatal_and_exit '-E- makexml -dvd *.VOB -out dvd failed'
660 # replace the first line of the xml file to remove the bad dest path
661 awk -v line=1 -v new_content="<dvdauthor>" '{
667 }' dvd.xml > dvd.xml.new
668 mv -f dvd.xml.new dvd.xml
670 fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
673 # remove the "<video " property line from the xml file
674 cat dvd.xml | grep -v "<video" > dvd.xml.new
675 mv -f dvd.xml.new dvd.xml
677 fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
680 # remove the extra <pgc>..</pgc> pairs
681 cat dvd.xml | awk 'BEGIN {x=1}
683 if ($0~"</pgc>") {x=0}
685 if ($0~"<pgc>") {x=1}
687 echo -e "</pgc>\n</titles>\n</titleset>\n</dvdauthor>" >> dvd.xml.new
688 mv -f dvd.xml.new dvd.xml
690 fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
693 # remove the VTS_*_0.VOB file as this is just the main menu video clip
694 cat dvd.xml | grep -v "VTS_.*_0.VOB" > dvd.xml.new
695 mv -f dvd.xml.new dvd.xml
697 fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
701 function check_for_mplayer_dumpstream_incompatibility {
703 echo "-> Checking for mplayer dumpstream incompatibilities" | tee -a "$logfile"
705 if [ ! -e "$vobfile" ]; then
706 # mplayer dumpstream does not work on DVDs that obscure the feature title.
707 # A DVD that has 99 titles, where the longest title isn't the main feature
708 # breaks mplayer dumpstream. We have to fallback to using dvdbackup to figure
709 # out what the feature title is. This script will run through that flow if we
710 # set use_mplayer_dumpstream to 0. Check for this here.
711 if [ $ripdvd -eq 1 ]; then
712 lsdvd $dev | grep -q "Title: 99"
714 lsdvd "$isofile" | grep -q "Title: 99"
716 # If we have 99 titles and a feature title wasn't given on the command line, switch modes.
717 if [ $? == 0 ] && [ $feature_title_override -eq 0 ]; then
718 if [ $trust_feature_title_autodetect_when_uncertain -eq 0 ]; then
719 echo "-E- Unable to determine the feature title due to the 99 title copy protection scheme" | tee -a "$logfile"
720 echo " You will need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
721 invalid_feature_title=1
723 echo " Falling back to non mplayer dumpstream methods to copy the DVD" | tee -a "$logfile"
724 echo "-W- We still may not be able to autodetect the right feature title" | tee -a "$logfile"
725 echo " You may need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
726 use_mplayer_dumpstream=0
727 invalid_feature_title=1
733 # There is another form of protection that causes the mplayer dumpstream to fail.
734 # This can be detected by telling mplayer to parse the VOB file by copying its audio
735 # video streams to a dummy output file (/dev/null). Do that here to check for that
736 # problem before continuing.
737 if [ -e "$vobfile" ]; then
738 mplayer_opts="-quiet -ofps 30000/1001 -ffourcc DIVX -oac copy -ovc copy"
739 mencoder $mplayer_opts "$vobfile" -o "/dev/null" > $dumplog 2>&1
740 grep -q "Too many audio packets in the buffer" $dumplog
742 echo "-> The VOB dumped by mplayer is invalid. Falling back to non mplayer dumpstream to copy the DVD" | tee -a "$logfile"
743 use_mplayer_dumpstream=0
744 mplayer_dumpstream_incompatibility=1
746 [[ -e "$dumplog" ]] && rm -f $dumplog
750 function fill_mythvideo_metadata {
752 # This function must be passed the filename as an argument
753 # The filename must be a full path to the file
756 # Make sure the fill mythvideo metadata option has been set to 1
757 if [ $fill_mythvideo_metadata -eq 0 ]; then
758 echo "-> fill_mythvideo_metadata=0 therefore not updating mythvideo metadata for this rip" | tee -a "$logfile"
762 # If the fill mythvideo metadata script is present, run it
763 # fill_mythvideo_metadata.plThis will download the metadata for the DVD we ripped.
764 if [[ -x `which fill_mythvideo_metadata.pl` ]]; then
765 echo "-> Running fill_mythvideo_metadata.pl to lookup/add/update the metadata for this DVD: $filename" | tee -a "$logfile"
766 fill_mythvideo_metadata.pl -N 0 -F "$filename" >> "$logfile" 2>&1
768 echo "-W- Unable to find the fill_mythvideo_metadata.pl script in your PATH. Unable to autofill the mythvideo DB for this rip." | tee -a "$logfile"
769 echo " Set the fill_mythvideo_metadata variable to 0 in the script to avoid running this step." | tee -a "$logfile"
773 function remove_intermediate_vob_file {
774 # remove the intermediate VOB file
775 if [ $keep_intermediate_files -eq 0 ]; then
776 [[ -e "$tmpdir/$dvdname.VOB" ]] && rm -f "$tmpdir/$dvdname.VOB"
778 echo "-> Keeping intermediate concatenated VOB file: $tmpdir/$dvdname.VOB" | tee -a "$logfile"
782 function remove_intermediate_iso_file {
783 # remove the original DVD image
784 if [ $keep_intermediate_files -eq 0 ]; then
785 [[ -e "$isofile" ]] && rm "$isofile"
787 echo "-> Keeping ddrescue intermediate iso file: $isofile" | tee -a "$logfile"
791 function remove_intermediate_dvdbackup_folder {
792 if [ $keep_intermediate_files -eq 0 ]; then
793 [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
795 echo "-> Keeping intermediate dvdbackup folder: $tmpdir/$dvdname" | tee -a "$logfile"
799 ###############################################
802 # Make a note of when this DVD rip started
804 echo -e "\n$date DVD rip started" >> "$logfile"
806 # Rip the DVD - Mirror Mode
807 if [ $mirror_mode -eq 1 ]; then
808 echo "-> Ripping DVD $dvdname to $dest"
810 # use ddrescue to make an ISO image of the disk
811 make_dvd_iso_image "$dest/$dvdname.iso"
813 # add this video data to the mythtv DB
814 fill_mythvideo_metadata "$dest/$dvdname.iso"
816 # eject the disk upon completion
820 echo "$date DVD rip completed" | tee -a "$logfile"
822 if [[ -n "$mailto" ]]; then
823 cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"
828 # Rip the DVD - Main Title Feature Only
829 if [ $mirror_mode -eq 0 ]; then
832 if [ $ripdvd -eq 1 ]; then
833 echo "-> Ripping DVD $dvdname to $dest" | tee -a "$logfile"
834 # use ddrescue to make an ISO image of the disk
835 make_dvd_iso_image "$tmpdir/$dvdname.iso"
838 # Rip image from DVD path
839 if [ -n "$dvdpath" ]; then
840 echo "-> Ripping DVD $dvdpath to $dest" | tee -a "$logfile"
841 make_dvd_iso_image_from_folder "$dvdpath" "$tmpdir/$dvdname.iso" 1
844 # make sure our isofile value is set
845 if [ -z "$isofile" ]; then
846 isofile="$tmpdir/$dvdname.iso"
849 if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_avi -eq 1 ]; then
851 if [ ! -e "$vobfile" ]; then
852 echo "-> Creating DVD video $vobfile" | tee -a "$logfile"
854 # get the feature title from the ISO
855 get_feature_title "$isofile"
857 # get the crop value from the ISO
860 # check for mplayer dumpstream incompatibilities
861 # if they exist, this method will set this mode to 0.
862 check_for_mplayer_dumpstream_incompatibility
864 if [ $use_mplayer_dumpstream -eq 1 ]; then
866 # get our audio id from the ISO file
867 get_audio_id_from_iso "$isofile"
869 # create our main VOB file from the ISO
870 create_main_vob_with_mplayer "$isofile"
872 # remove the intermediate VOB file
873 remove_intermediate_vob_file
875 # it's possible that our VOB is still corrupted in some manner
876 # check to make sure it is still a good VOB before continuing.
877 check_for_mplayer_dumpstream_incompatibility
881 if [ $use_mplayer_dumpstream -eq 0 ]; then
883 # use dvdbackup to make a DVD folder of the feature title
884 make_dvdbackup_folder_image
886 # create our main VOB file
887 create_main_vob_with_cat
889 # get our audio id from the VOB file
890 get_audio_id_from_vob "$tmpdir/$dvdname.VOB"
892 # check for corrupted VOB start
893 check_vob_for_corrupted_start
895 # check to make sure our VOB is complete
896 check_vob_for_completeness
898 # check to make sure our VOB doesn't have too many video packets
899 check_vob_for_too_many_video_packets
901 # check to make sure our VOB doesn't have a52 crc errors
902 check_vob_for_a52_crc_errors
904 # remove the intermediate VOB file
905 remove_intermediate_vob_file
909 # remove the intermediate ISO file
910 remove_intermediate_iso_file
913 echo "-> Skipping VOB creation. VOB DVD video already exists: $vobfile" | tee -a "$logfile"
917 if [ $make_final_dest_avi -eq 1 ]; then
918 echo "-> Encoding the DVD video to an AVI file" | tee -a "$logfile"
920 # determine what our bitrate needs to be if a target size was specified instead
921 calculate_bitrate_from_target_size
923 # There was a lot of experimentation to arrive at these values
924 # These seem to work OK for me. If they don't work for you, feel
925 # free to adjust/change as needed.
927 # Edit these as needed to suite your needs
928 mencoder_general_opts="-quiet $lang_opts -passlogfile $passlogfile"
929 mencoder_output_opts="-ofps 30000/1001 -ffourcc DIVX"
930 mencoder_video_filter_opts="-vf pullup,softskip,hqdn3d=2:1:2$CROP"
931 mencoder_video_encoder_opts="-ovc xvid -xvidencopts pass=%PASS:chroma_opt:vhq=4:bvhq=1:quant_type=mpeg:bitrate=$target_bitrate:autoaspect:threads=$mencoder_threads"
933 # There are a number of different ways to encode 6 channel audio.
934 # I've loaded 3 different ways into the mencoder_audioch_opts.
935 # It will cycle through them until it finds one that works.
936 # You can change the order to suit your needs.
937 if [ $audio_2ch -eq 0 ]; then
939 # These options produce good 6 channel audio for the internal mythvideo player, but they can't play in Windows.
940 #mencoder_audio_opts="-oac lavc -lavcopts acodec=ac3"
941 #mencoder_audioch_opts[0]="-channels 6 -af channels=6:6:0:5:1:4:2:3:3:2:4:1:5:0"
943 # These options produce good 6 channel audio for linux and windows (except the internal mythvideo player)
944 # This option requires playback under linux with mplayer to be done with options: -channels 6 -ac hwac3,hwdts,mad
945 mencoder_audio_opts="-oac copy"
947 # There are 3 different ways to specify 6 channel encoding. We'll try the other ones in order if one of them fails.
948 mencoder_audioch_opts[0]="-channels 6 -af channels=6"
949 mencoder_audioch_opts[1]="-af channels=6"
950 mencoder_audioch_opts[2]=""
953 # These options produce good 2 channel audio for linux and windows (including the internal mythvideo player)
954 mencoder_audio_opts="-oac mp3lame -lameopts cbr:br=$audio_bitrate"
955 mencoder_audioch_opts[0]=""
958 # Do not edit this line. $mencoder_video_encoder_opts must be last
959 mencoder_opts="$mencoder_general_opts $mencoder_output_opts $mencoder_audio_opts $mencoder_video_filter_opts $mencoder_video_encoder_opts"
964 # Set some options based on which pass we are in
965 mencoder_opts_for_pass=$(echo "$mencoder_opts" | sed "s,%PASS,$PASS,g")
966 [ $PASS -eq 1 ] && mencoder_opts_for_pass="$mencoder_opts_for_pass:turbo"
967 [ $PASS -eq 1 ] && output_file="/dev/null"
968 [ $PASS -eq 2 ] && output_file="$dest/$dvdname.avi"
970 # It's possible that the audio channel encoding may not work. Cycle through all our different audioch_opts until we find one that works.
971 for CH_OPTS in "${mencoder_audioch_opts[@]}";
973 echo -e " Encoding pass $PASS"
974 echo -e "\n Encoding pass $PASS: mencoder $CH_OPTS $mencoder_opts_for_pass \"$vobfile\" -o \"$output_file\" >> $encodelog 2>&1" >> "$logfile"
975 mencoder $CH_OPTS $mencoder_opts_for_pass "$vobfile" -o "$output_file" > $encodelog 2>&1
977 grep -q "\[channels\] Invalid" $encodelog
981 echo -e "\n-W- Audio channel encoding error. Falling back to next audio channel encoding scheme." >> "$logfile"
984 if [ $mencoder_retval != 0 ]; then
985 fatal_and_exit "-E- Unhandled mencoder error"
987 # Concatenate the encode log to our main log file, greping out unwanted lines
988 cat $encodelog | grep -v "Pos:" >> "$logfile"
991 if [ $keep_intermediate_files -eq 0 ] && [ $make_final_dest_vob -eq 0 ]; then
992 [[ -e "$vobfile" ]] && rm -f "$vobfile";
993 [[ -e "$passlogfile" ]] && rm -f "$passlogfile";
995 echo "-> Keeping VOB file: $vobfile" | tee -a "$logfile"
996 echo "-> Keeping mencoder 2pass logfile: $passlogfile"
1000 # add this video data to the mythtv DB
1001 [ $make_final_dest_avi -eq 1 ] && fill_mythvideo_metadata "$dest/$dvdname.avi"
1002 [ $make_final_dest_vob -eq 1 ] && fill_mythvideo_metadata "$vobfile"
1006 # use dvdbackup to make a DVD folder of the feature title
1007 make_dvdbackup_folder_image
1009 # cd to the feature title DVD folder
1010 pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
1011 if [ $? != 0 ]; then
1012 fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
1015 # create the dvd.xml file for dvdauthor
1016 create_dvdauthor_dvd_xml_file
1018 # make the final DVD folder image
1019 make_dvdauthor_folder_image
1021 # add this video data to the mythtv DB
1022 fill_mythvideo_metadata "$dest/$dvdname/VIDEO_TS"
1024 # cd back to the dir we started from
1025 popd > /dev/null 2>&1
1027 if [ $make_final_dest_iso -eq 1 ]; then
1029 # make an iso image out of our directory
1030 make_dvd_iso_image_from_folder "$dest/$dvdname" "$dest/$dvdname.iso" 0
1032 # If the mkisofs was unable to make a .iso file for us, don't remove the DVD directory
1033 if [ -s "$dest/$dvdname.iso" ]; then
1034 if [ $make_final_dest_folder -eq 0 ]; then
1035 echo "-> Removing DVD folder since ISO was created: $dest/$dvdname" | tee -a "$logfile"
1036 # remove the folder of the DVD image now that we have a .iso version of it
1037 [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
1040 # we created an empty iso file, remove it
1041 echo "-> Removing empty ISO image: $dest/$dvdname.iso" | tee -a "$logfile"
1042 echo "-> Keeping the DVD folder since the ISO image couldn't be created properly: $dest/$dvdname"
1043 [[ -e "$dest/$dvdname.iso" ]] && rm "$dest/$dvdname.iso"
1046 # add this video data to the mythtv DB
1047 fill_mythvideo_metadata "$dest/$dvdname.iso"
1053 # remove the ddrescue DVD ISO image
1054 remove_intermediate_iso_file
1056 # remove the tmp dvdbackup folder of the DVD image
1057 remove_intermediate_dvdbackup_folder
1059 # eject the DVD disk upon completion
1060 [ $ripdvd -eq 1 ] && eject -T $dev
1063 echo "$date DVD rip completed" | tee -a "$logfile"
1065 if [[ -n "$mailto" ]]; then
1066 cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"